// ****************************************************************************
// copyright (c) 2000-2005 Horst Knorr <hk_classes@knoda.org>  
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file LGPL included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************

#ifndef HK_KDEREPORTPART
#define HK_KDEREPORTPART
#include <kparts/genericfactory.h>
#include <kparts/part.h>
#include "../hk_kdeclasses/hk_kdereportpartwidget.h"

class hk_drivermanager;
class hk_kdereportpartprivate;

class hk_kdereportpart : public KParts::ReadWritePart
{
friend class hk_kdereportpartwidget;
    Q_OBJECT
        public:
        hk_kdereportpart(QWidget* parentWidget, const char* widgetname,QObject* parent, const char* name, const QStringList &args);
        virtual ~hk_kdereportpart();
        static KAboutData* createAboutData();
        virtual void setReadWrite(bool rw);
    protected:
        virtual bool openFile();
        virtual bool saveFile();
	virtual void setXMLFile(const QString& file,bool merge=false,bool setxmldoc=true);

    protected slots:
//        virtual void show_dbdesignercolumndialog(void);
//   	virtual void add_action(void);
    private:
      hk_kdereportpartprivate* p_private;

};


#endif
